; TIP1044.LSP: DIMFLIP    Flip Vertical Dimensions   (c)1994, Dan Adlon

;   Program to fip leader and text  of vertical dimensions
;   Written by Dan Adlon

;--- c:dimflip ----------------------------------------------
; routine to pick a vertical dimension to flip

(defun c:df (/ ent dxf data)
   (defun dxf (x)(cdr (assoc x data)))

   (cond
   ((setq ent (entsel "\nPick a DIMENSION: "))
      
       (setq data (entget (car ent)))
       (if (= "DIMENSION" (dxf 0))
           (flip (dxf 2))
           (princ "... not a DIMENSION....program aborted")
       )
   )
   (T (princ "... no entity found."))
   )
   (princ)
)
;
;-----routine to sequence thru dimension block to the leader line-----
;
(defun flip (bname / data dxf test)

     (defun dxf (x) (cdr (assoc x data)))
   
     (setq data (tblsearch "block" bname))
     (setq data (dxf -2)
           data (entget data)
     )
     (repeat 4
          (setq data (entnext (dxf -1))
                data (entget data)
          )
     )     
     (if (= "LINE" (dxf 0))
          (progn
               (setq line data)
               (setq data (entnext (dxf -1))
                     data (entget data)
               )
               (while data
                    (if (= "TEXT" (dxf 0))
                         (progn
                              (setq dimtext data)
                              (texttest)
                         )
                         (if (setq data (entnext (dxf -1)))
                             (setq data (entget data))
                             (progn
                                 (setq data nil)
                                 (princ "...No text found... program aborted...")
                              )
                         )
                    )
               )
          )
          (princ "...Not a VERTICAL DIMENSION...program aborted....")
     )
     (command "regen")
     (princ)
)
;
;-----routine to test for tolerance text-----------------------------
;
(defun texttest ()
     
     (defun dxf (x) (cdr (assoc x data)))

     (setq data (entnext (dxf -1))
           data (entget data)
     )

     (if (= "TEXT" (dxf 0))
         (progn
             (setq minustol data)
             (setq data (entnext (dxf -1))
                   plustol (entget data)
             )
             (fliptol)
         )
         (flipstd)
     )
)
;
;-----routine to flip a standard dimension---------------------------
;
(defun flipstd ()
     
     (flipline)
     (setq dimtextpt (assoc 11 dimtext))
     (setq diff (mapcar '- pt1 dimtextpt))
     (setq newpt (mapcar '+ pt1 diff (list 2 0 0 0)))
     (setq dimtext 
          (subst newpt
                 (assoc 11 dimtext)
                 dimtext
          )
     )
     (entmod dimtext)
     (setq data nil)
)
;
;-----routine to flip a toleranced dimension--------------------------
;
(defun fliptol ()
     (setq flipptx (cadr (assoc 10 line)))
     (setq pta (cadr (assoc 10 dimtext)))
     (setq ptb (cadr (assoc 10 minustol)))
     (setq dimtextpt (cadr (assoc 11 dimtext)))
     (setq minustolpt (cadr (assoc 11 minustol)))
     (setq plustolpt (cadr (assoc 11 plustol)))
     (setq deltax (+ (- flipptx pta)
                     (- flipptx minustolpt)
                     (- ptb minustolpt)
                  )
     )
     (setq deltax (list 0 deltax 0 0))

     (flipline)

     (setq dimtextpt (assoc 11 dimtext))
     (setq newpt (mapcar '+ dimtextpt deltax))
     (setq dimtext 
          (subst newpt
                 (assoc 11 dimtext)
                 dimtext
          )
     )
     (entmod dimtext)

     (setq plustolpt (assoc 11 plustol))
     (setq newpt (mapcar '+ plustolpt deltax))
     (setq plustol 
          (subst newpt
                 (assoc 11 plustol)
                 plustol
          )
     )
     (entmod plustol)

     (setq minustolpt (assoc 11 minustol))
     (setq newpt (mapcar '+ minustolpt deltax))
     (setq minustol 
          (subst newpt
                 (assoc 11 minustol)
                 minustol
          )
     )
     (entmod minustol)

     (setq data nil)
)
;
;-----routine to flip dimension leader line---------------------------
;
(defun flipline ()
     (setq pt1 (assoc 10 line)
           pt2 (assoc 11 line)
           diff1 (mapcar '- pt1 pt2)
           newpt2 (mapcar '+ pt1 diff1 (list 2 0 0 0)))
     (setq line 
          (subst newpt2
                 (assoc 11 line)
                 line
          )
     )
     (entmod line)
(princ)
); end dimflip.lsp
